VERSION 5.00
Object = "{9DC38830-6838-11D2-89E0-0040051D6CCA}#1.0#0"; "APXIMA~2.DLL"
Object = "{D22FEEE0-7890-11D2-89E0-0040051D6CCA}#1.0#0"; "APXIMAGE.DLL"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "Display Context & Contrast / Brightness Tuning sample"
   ClientHeight    =   5670
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6255
   LinkTopic       =   "Form1"
   ScaleHeight     =   5670
   ScaleWidth      =   6255
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.Slider Brightness 
      Height          =   4095
      Left            =   5640
      TabIndex        =   9
      Top             =   360
      Width           =   630
      _ExtentX        =   1111
      _ExtentY        =   7223
      _Version        =   327680
      MouseIcon       =   "Form1.frx":0000
      Orientation     =   1
      LargeChange     =   20
      SmallChange     =   5
      TickStyle       =   2
      TickFrequency   =   20
   End
   Begin ComctlLib.Slider Contrast 
      Height          =   4095
      Left            =   4920
      TabIndex        =   8
      Top             =   360
      Width           =   630
      _ExtentX        =   1111
      _ExtentY        =   7223
      _Version        =   327680
      MouseIcon       =   "Form1.frx":001C
      Orientation     =   1
      LargeChange     =   20
      SmallChange     =   5
      TickStyle       =   2
      TickFrequency   =   20
   End
   Begin VB.TextBox DCHi 
      Height          =   375
      Left            =   2520
      TabIndex        =   7
      Text            =   "120"
      Top             =   5160
      Width           =   855
   End
   Begin VB.TextBox DCLo 
      Height          =   375
      Left            =   1560
      TabIndex        =   6
      Text            =   "50"
      Top             =   5160
      Width           =   855
   End
   Begin VB.CommandButton ManualDC 
      Caption         =   "Manual DC"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   5100
      Width           =   1215
   End
   Begin VB.CommandButton StandardDC 
      Caption         =   "Standard DC"
      Height          =   495
      Left            =   1560
      TabIndex        =   4
      Top             =   4560
      Width           =   1215
   End
   Begin VB.CommandButton NormalizedDC 
      Caption         =   "Normalized DC"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   4560
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "B"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5880
      TabIndex        =   2
      Top             =   120
      Width           =   255
   End
   Begin VB.Label Label1 
      Caption         =   "C"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5160
      TabIndex        =   1
      Top             =   120
      Width           =   255
   End
   Begin ApxImageLibCtl.ApxImage ApxImage1 
      Left            =   1560
      OleObjectBlob   =   "Form1.frx":0038
      Top             =   3840
   End
   Begin ApxImageDisplayLib.ApxImageDisplay ApxImageDisplay1 
      Height          =   4455
      Left            =   0
      OleObjectBlob   =   "Form1.frx":005C
      TabIndex        =   0
      Top             =   0
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const PI = 3.141592653
Private Sub Brightness_Scroll()
  UpdateLUT
End Sub
Private Sub Contrast_Scroll()
  UpdateLUT
End Sub
Private Sub Form_Load()
  Me.ApxImage1.Read "c:\program files\aphelion\images\Blood.tif"
  Me.ApxImageDisplay1.Image = Me.ApxImage1
End Sub
Private Sub UpdateLUT()
  Dim LUT As New ApxLUT
  LUT.Length = 256
'
  Dim Angle As Double, Slope As Double, B As Double, Origin As Double
'
  Angle = PI / 4 * (1 + (-Contrast.Value / 51))
  Slope = Tan(Angle)
  B = 256 * -Brightness.Value / 100
  Origin = 127 - Slope * (128 - B)
'
  Dim I As Integer, NDG As Integer
  For I = 0 To 255
    NDG = Slope * I + Origin
    If NDG < 0 Then
      NDG = 0
    End If
    If NDG > 255 Then
      NDG = 255
    End If
    LUT.Red(I) = NDG
    LUT.Green(I) = NDG
    LUT.Blue(I) = NDG
  Next I
'
  Me.ApxImageDisplay1.LUT = LUT
End Sub
Private Sub ManualDC_Click()
  Dim DC As New ApxStdDisplayContext
  Dim IDC As IApxImageDisplayContext
  Dim Range As New ApxDRange
  
  Range.Minimum = DCLo
  Range.Maximum = DCHi
  
  Set IDC = DC
  IDC.InputRangeMethod = irmManual
  IDC.InputRange = Range

  Me.ApxImageDisplay1.DisplayContext = DC
  
  Me.ApxImageDisplay1.Image = Me.ApxImage1
End Sub
Private Sub NormalizedDC_Click()
  Dim DC As New ApxStdDisplayContext
  Dim IDC As IApxImageDisplayContext
  Set IDC = DC
  IDC.InputRangeMethod = irmData

  Me.ApxImageDisplay1.DisplayContext = DC
  
  Me.ApxImageDisplay1.Image = Me.ApxImage1
End Sub
Private Sub StandardDC_Click()
  Dim DC As New ApxStdDisplayContext
  Dim IDC As IApxImageDisplayContext
  Set IDC = DC
  IDC.InputRangeMethod = irmDataType

  Me.ApxImageDisplay1.DisplayContext = DC
  
  Me.ApxImageDisplay1.Image = Me.ApxImage1
End Sub
